
#    Note:  This is loaded into the namespace  Clock

# variable started 0

if {![info exists started]} {variable started 0}

if {$started != 0} {

     variable JS ""
     variable LogFlag

     if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    do_click
}

if {$started == 0} {           ;#  first time load code and define local variables
    set started 1

#************************** Constant Definitions *****************************/
variable  REGMAXNO 15





#reg0-7 fields. 
variable  REG0_RESET	0x80000000
variable  REG0		0x10070600
variable  REG0_STEP2	0x18070600	;#sets Zero Delay Mode
variable  REG1		0x00060600
variable  REG2		0x00060600
variable  REG3		0x00060600
variable  REG4		0x00070600
variable  REG5		0x00070600
variable  REG6		0x00070600
variable  REG7		0x00070620


#reg8 default value
variable  REG8 0x10000900

#reg9 fields
variable  REG9 0xA0022A00

#reg10 fields
variable  REG10 0x00000000

#reg11 fields
variable  REG11 0x00828000

#reg12 fields
variable  REG12 0x00000000

#reg13 fields
variable  REG13 0x028C8000

#reg14 fields
variable  REG14 0x08300200

#reg15 fields
variable  REG15 0xC8001800
variable  REG15_STEP2   0xC8000200



    variable ShowLogFlag 0

    variable LogText ""
    variable LogFlag 0
    variable LogCount 0

    variable JS ""

    variable ClockList {0 1}
    variable Clock [first $ClockList]

    variable allmodules 0
    variable allClocks 0

    variable Clock_status {0 0}

    for {set i 0} {$i < 16} {incr i} {
        variable Opts.Value$i 0
    }

    variable         Opts.Offset0 0x00
    variable         Opts.Title0  "Reset and Clock 0 Output control"

    variable         Opts.Offset1 0x01
    variable         Opts.Title1  "Clock 1 Output control"

    variable         Opts.Offset2 0x02
    variable         Opts.Title2  "Clock 2 Output control"

    variable         Opts.Offset3 0x03
    variable         Opts.Title3  "Clock 3 Output control"

    variable         Opts.Offset4 0x04
    variable         Opts.Title4  "Clock 4 Output control"

    variable         Opts.Offset5 0x05
    variable         Opts.Title5  "Clock 5 Output control"

    variable         Opts.Offset6 0x06
    variable         Opts.Title6  "Clock 6 Output control"

    variable         Opts.Offset7 0x07
    variable         Opts.Title7  "Clock 7 Output control"

    variable         Opts.Offset8 0x08
    variable         Opts.Title8  "Not User Programmable"

    variable         Opts.Offset9 0x09
    variable         Opts.Title9  "Output Power Control"

    variable         Opts.Offset10 0x0A
    variable         Opts.Title10  "Not User Programmable"

    variable         Opts.Offset11 0x0B
    variable         Opts.Title11  "Phase Detector Frequency"

    variable         Opts.Offset12 0x0C
    variable         Opts.Title12  "Not User Programmable"

    variable         Opts.Offset13 0x0D
    variable         Opts.Title13  "Filter Values"

    variable         Opts.Offset14 0x0E
    variable         Opts.Title14  "Global Enables and PLL R controls"

    variable         Opts.Offset15 0x0F
    variable         Opts.Title15  "VCO and PLL N controls"



   proc  show_variables {} {
       variable allmodules 
       variable allClocks
       variable Clock

       InsertLog "FEE64 = $::AIDA::FEE64; Clock Chip = $Clock"
       InsertLog "all modules = $allmodules; all Clock Chips = $allClocks"
   }

   proc do_redisplay {} {
     variable Clock
     variable Clock_status
     set status [ ReadAIDARegister 1 ]
     lset Clock_status 0 [ expr $status & 1 ]
     lset Clock_status 1 [ expr ($status >> 1 ) & 1 ]
   }

   proc do_setOptS {i } {

      variable Opts.Value$i
	do_setOpt $i [ set Opts.Value$i ]

   }



   proc do_setOpt {i vl} {
      variable Clock
      variable ClockList
      variable allClocks
      variable allmodules
      variable Opts.Offset$i
      variable Opts.Value$i

      set BAK $::AIDA::FEE64
	
      set Opts.Value$i $vl
      foreach fee64 $::AIDA::ModuleMenu {
          if {$allmodules == 0 && $fee64 != $::AIDA::FEE64} continue

          set ::AIDA::FEE64 $fee64
          foreach item $ClockList {
              if {$allClocks == 0 && $item != $Clock} continue
		set full_value [ expr [set Opts.Value$i] + $i ]
              BBLMK_register $item $full_value
	      InsertLog "Write LMK3200 number $item  register $i with [ format "%08X" $full_value ] "
          }
 
      }

      set ::AIDA::FEE64 $BAK
   }

   proc BBLMK_register { chip value } {
	set sequence {}
	set Breg 0x1
	WriteAIDARegister 13 $Breg ; # select the bit bashing route and pull the two LEuWire low.


	lappend sequence [ format "%02X" $Breg ]
	for { set i 0 } { $i < 32 } { incr i } {
		set Bval [ expr (((  $value >> ( 31 - $i ) ) & 1 ) << 2 ) ] ; # get the data bit MSB first

		if { $Bval == 0 } { set Breg 0x1 } else { set Breg 0x5 } ; # set or clear the data bit
		
		WriteAIDARegister 13 $Breg ; # Apply the Data bit . 
		lappend sequence [ format "%02X" $Breg ]
		set BClk [ expr $Breg | 2 ]
		WriteAIDARegister 13 $BClk ; # Apply the Clock . 
		lappend sequence [ format "%02X" $BClk ]
		WriteAIDARegister 13 $Breg ; # remove the Clock . 
		lappend sequence [ format "%02X" $Breg ]
	} ; # should loop and set the data and reset the clock , then set the clock again for all the data bits.

	set Breg [ expr ( 1 << ( $chip + 3) ) + 1   ] ;# set the LEuWire bit for the chosen chip and set the bit bashing route.
	WriteAIDARegister 13 $Breg ; 
	lappend sequence [ format "CS = %02X\n" $Breg ]
	set Breg 0x1
	WriteAIDARegister 13 $Breg ; # select the bit bashing route and pull the two LEuWire low.
	lappend sequence [ format "%02X" $Breg ]
	InsertLog "$sequence"	
   }

   proc Calibrate {} {
      variable Clock
      variable ClockList
      variable allClocks
      variable allmodules
      variable REG0_RESET


      set BAK $::AIDA::FEE64

      foreach fee64 $::AIDA::ModuleMenu {
          if {$allmodules == 0 && $fee64 != $::AIDA::FEE64} continue

          set ::AIDA::FEE64 $fee64
# copied from RunControl/sys.tcl to work out the clock source
	set Clock_source "MACB"
        set fw_string [ReadAIDARegister [expr 0x000 + 10]]
	if { ( ( $fw_string >> 24 ) & 0xff ) == 0x38 } {
		set d1 [ expr ( ( $fw_string >> 8 ) & 0xf ) ]
		set d2 [ expr  ( $fw_string  & 0xf ) ]
		set FW_text "V8.$d1$d2"
	} else {
		if { (( $fw_string >> 24 ) & 0xff ) == 0x49 } {
			set d1 [ expr ( ( $fw_string >> 8 ) & 0xf ) ]
			set d2 [ expr  ( $fw_string  & 0xf ) ]
			if { $d1 == 5 } { set Clock_source "White Rabbit" }
			set FW_text "ISOL.$d1$d2"
		}
	}
          if { $Clock_source == "White Rabbit" } {
		WriteAIDARegister [expr 0x000 + 5] 0x01B    ;#  select clock from external 200MHz with divide by 4
	  } else {
 		WriteAIDARegister [expr 0x000 + 5] 0x0B    ;#  select clock from HDMI
	  }
 
          foreach item $ClockList {
              if {$allClocks == 0 && $item != $Clock} continue
              		BBLMK_register $item $REG0_RESET
		for { set i 0 } { $i < 16 } { incr i } {
      			variable Opts.Value$i
			set full_value [ expr [set Opts.Value$i] + $i ]
              		BBLMK_register $item $full_value
		}

          }

# SYNC the LMK3200 clock outputs to the input.

          if { $Clock_source == "White Rabbit" } {
		WriteAIDARegister [expr 0x000 + 5] 0x1A    ;#  select clock from external 200MHz with divide by 4 + reset DCMs
	  } else {
 		WriteAIDARegister [expr 0x000 + 5] 0x0A    ;#  select clock from HDMI
	  }
          if { $Clock_source == "White Rabbit" } {
		WriteAIDARegister [expr 0x000 + 5] 0x1b    ;#  select clock from external 200MHz with divide by 4
	  } else {
 		WriteAIDARegister [expr 0x000 + 5] 0x0b    ;#  select clock from HDMI
	  }

# now reset the FPGA Internal DCMs

          if { $Clock_source == "White Rabbit" } {
		WriteAIDARegister [expr 0x000 + 5] 0x3b    ;#  select clock from external 200MHz with divide by 4 + reset DCMs
	  } else {
 		WriteAIDARegister [expr 0x000 + 5] 0x2b    ;#  select clock from HDMI
	  }


          if { $Clock_source == "White Rabbit" } {
		WriteAIDARegister [expr 0x000 + 5] 0x01b    ;#  select clock from external 200MHz with divide by 4
	  } else {
 		WriteAIDARegister [expr 0x000 + 5] 0x0b    ;#  select clock from HDMI
	  }
  
 
      }

      set ::AIDA::FEE64 $BAK
   }



   proc DEFAULT {} {
     for {set i 0} {$i < 16} {incr i} {
	 variable Opts.Value$i
	 variable REG$i
	 set Opts.Value$i [ set REG$i ]
     }

   }

   proc  do_click {}  {
       variable cgidata
       variable started
       variable LogFlag
       variable ShowLogFlag

       set cgidata [ncgi::nvlist]

       if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

       if {[llength $cgidata] == 0} then {return}

       if {[llength $cgidata] < 2} then {
           InsertLog "CGI data is too short: $cgidata"
       } else {
           if {[lindex $cgidata 0] != "Widget"} then {
               InsertLog "Invalid CGI data: $cgidata"
           } else {

              set w [first [lindex $cgidata 1]]
              set vl [second [lindex $cgidata 1]]

               switch -glob $w {

                   RESET    {set started 0}
                   CLEAR    {EmptyLog}
                   ELOG     {PrintLog}
                   RELOAD   {}
                   VARIABLES {show_variables}

                   HIDE     {set ShowLogFlag 0}
                   SHOW     {set ShowLogFlag 1}
                   LOGON    {set LogFlag 1}
                   LOGOFF   {set LogFlag 0}

                   MODULE     {set ::AIDA::FEE64 $vl}
                   ALLMODULES {variable allmodules; set allmodules [expr ($allmodules + 1) & 1]}

                   CLOCK     {variable Clock; set Clock $vl}
                   ALLCLOCKS {variable allClocks; set allClocks [expr ($allClocks + 1) & 1]}

                   OPT      {do_setOpt [second [lindex $cgidata 1]] [third [lindex $cgidata 1]]}
                   OPTS     {do_setOptS [second [lindex $cgidata 1]]}

                   EXPERT   {$vl}

                   MainLog {}
                   undefined {}
                   default {InsertLog "unexpected CGI data:  $cgidata"}
               }
           }
        }
        do_redisplay
     }

     do_redisplay

}   ;# end of if {$started == 0}




