
#    Note:  This is loaded into the namespace  Check

# variable started 0

if {![info exists started]} {variable started 0}

if {$started != 0} {

     variable JS ""
     variable LogFlag

     if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    do_click
}

if {$started == 0} {           ;#  first time load code and define local variables
    set started 1

    variable ShowLogFlag 0

    variable LogText ""
    variable LogFlag 0
    variable LogCount 0

    variable JS ""
    variable SYNC_Base_Collected 0
    variable WR_Base_Collected 0

    variable allmodules 0
     

    for {set i 0} {$i <= 11} {incr i} {variable Opt$i 0}


   proc  show_variables {} {
       variable allmodules

       InsertLog "FEE64 = $::AIDA::FEE64"
       InsertLog "all modules = $allmodules"

   }
  proc do_clock_check {} {
    set TSMaster $::AIDA::TSMaster
      set BAK $::AIDA::FEE64   ;#   save
	set passed 0
	set failed 0
	set Mpassed 0
	set Mfailed 0
      foreach fee64 $::AIDA::ModuleMenu {
	          set ::AIDA::FEE64 $fee64
		 set Test1 [expr 7 & [ ReadAIDARegister 1] ]
		if { $Test1 == 0x07 } {
			set passed [ expr $passed + 1 ]
		} else {
			set failed [ expr $failed + 1 ]
			InsertLog "FEE64 module $fee64 global clocks failed, $Test1 "
		}
		 if { $fee64 == $TSMaster } {
			set Test2 [expr 0x10000 & [ ReadAIDARegister 0x40d] ]
			if { $Test2 == 0x10000 } {
				set Mpassed [ expr $Mpassed + 1 ]
			} else {
				set Mfailed [ expr $Mfailed + 1 ]
				InsertLog "FEE64 Master module $fee64 SYNC clock failed, $Test2"
			}
	      }
	}
	InsertLog "Clock status test result: Passed $passed, Failed $failed"
	InsertLog "Master Clock status test result: Passed $Mpassed, Failed $Mfailed"

      set ::AIDA::FEE64 $BAK   ;#   restore
   }

  proc do_cal_check {} {
      set BAK $::AIDA::FEE64   ;#   save
	set passed 0
	set failed 0
      foreach fee64 $::AIDA::ModuleMenu {
	          set ::AIDA::FEE64 $fee64
		 set Test1 [ ReadAIDARegister 0x802 ]
		 set Test2 [ ReadAIDARegister 0x803 ]
		 set Test3 [ ReadAIDARegister 0x804 ]
		if { $Test1 == 0xff && $Test2 == 0xf7 && $Test3 == 0xff } {
			set passed [ expr $passed + 1 ]
		} else {
			set failed [ expr $failed + 1 ]
			InsertLog "FEE64 module $fee64 failed"
		}
      }
	InsertLog "Calibration test result: Passed $passed, Failed $failed"
      set ::AIDA::FEE64 $BAK   ;#   restore
   }
  proc do_stamp_check {} {
      set BAK $::AIDA::FEE64   ;#   save
	set passed 0
	set failed 0
      foreach fee64 $::AIDA::ModuleMenu {
	          set ::AIDA::FEE64 $fee64
		 set Test1 [ ReadAIDARegister 0x309 ]
		if { $Test1 == 0x9f  } {
			set passed [ expr $passed + 1 ]
		} else {
			set failed [ expr $failed + 1 ]
			InsertLog "FEE64 module $fee64 failed"
		}
      }
	InsertLog "ASIC Clock Timestamp check test result: Passed $passed, Failed $failed"
      set ::AIDA::FEE64 $BAK   ;#   restore
   }

 proc do_sync_checkRx {} { ;# cause a resync but don't request slaves load their Timestamps and don't reset the SYNC counters
	set BAK $::AIDA::FEE64   ;#   save
      foreach fee64 $::AIDA::ModuleMenu {
	          set ::AIDA::FEE64 $fee64
		  WriteAIDARegister 0x400 1 ; # Force the Slave to not be in ReSYNC mode!
	}

	set ::AIDA::FEE64 $::AIDA::TSMaster   ;# select Master
            WriteAIDARegister 0x412 0            ;# write to copy timestamp 
            set MTimeH [ReadAIDARegister 0x413]   ;# read timestamp high 32 bits
            set MTimeL [ReadAIDARegister 0x412]   ;# read timestamp low 32 bits

            InsertLog "Current master timestamp from $::AIDA::FEE64 is $MTimeH $MTimeL"

            if {[expr ($MTimeL >> 28) & 0xf] >= 0xe} {
                set NewTimeL 0x20000000   ; # extended the period between the current time and the resync time by 0x10000000
                set NewTimeH [format 0x%08x [expr $MTimeH + 1]]
            } else {
                set NewTimeL [format 0x%08x [expr ($MTimeL & 0xf0000000) + 0x30000000]]
                set NewTimeH $MTimeH
            }

            WriteAIDARegister 0x417 $NewTimeL    ;#   load timestamp used by master to generate ReSYNC pulse
            WriteAIDARegister 0x418 $NewTimeH    ;# 

            WriteAIDARegister 0x410 0xB        ;#   master generates RESYNC request but doesn't reset the number of SYNCs issued.

            InsertLog "ReSync at time $NewTimeH $NewTimeL"
#    check status from the master

      for {set i 0} {$i < 10} {incr i} {

         set STATUS [ReadAIDARegister 0x411]    ;#  Master timestamp status
         if {$STATUS == 0x1} {
             InsertLog "Master ReSync done"
             break
         } else {
             after 2000  ;#  wait a bit longer
         }
      }

      if {$i == 10} {InsertLog "Warning: Master ReSync NOT complete"}
      WriteAIDARegister 0x410 1 ;# reset the ReSync request in the Master

 	set Master_issued [ ReadAIDARegister 0x41B ] ;# read the number the Master thinks it sent out
	InsertLog "Master issued [format "%d" $Master_issued ] SYNC pulses"
      foreach fee64 $::AIDA::ModuleMenu {
	          set ::AIDA::FEE64 $fee64
		  WriteAIDARegister 0x40F 1 ; # the slave will show the number of SYNCs received up to the ReSYNC.
		  set val [ ReadAIDARegister 0x407 ]
		  InsertLog "Slave $fee64 counted [format "%d" $val ] SYNC pulses"
		  WriteAIDARegister 0x40F 0 ; # the slave will show the number of SYNCs being counted.
	}
	set ::AIDA::FEE64 $BAK   ;#   restore
   }

 proc do_sync_check {} {
	variable SYNC_Base_Collected
      set BAK $::AIDA::FEE64   ;#   save
	set passed 0
	set failed 0
	if { $SYNC_Base_Collected == 0 } { Collect_SYNC_Base }

      foreach fee64 $::AIDA::ModuleMenu {
	          set ::AIDA::FEE64 $fee64
		 variable Sync_Base_$fee64
		 set Test1 [ ReadAIDARegister [ expr 0x400 + 14] ] 

		if { $Test1 == [ set Sync_Base_$fee64 ] } {
			set passed [ expr $passed + 1 ]
		} else {
			set failed [ expr $failed + 1 ]
			InsertLog "FEE64 module $fee64 failed. Base reading : [ set Sync_Base_$fee64 ] , Current reading $Test1 "
		}
      }
	InsertLog "Sync error counter test result: Passed $passed, Failed $failed"
      set ::AIDA::FEE64 $BAK   ;#   restore
   }

  proc do_stamp_check {} {
      set BAK $::AIDA::FEE64   ;#   save
	set passed 0
	set failed 0
      foreach fee64 $::AIDA::ModuleMenu {
	          set ::AIDA::FEE64 $fee64
		 set Test1 [ ReadAIDARegister 0x309 ]
		if { $Test1 == 0x9f  } {
			set passed [ expr $passed + 1 ]
		} else {
			set failed [ expr $failed + 1 ]
			InsertLog "FEE64 module $fee64 failed"
		}
      }
	InsertLog "ASIC Clock Timestamp check test result: Passed $passed, Failed $failed"
      set ::AIDA::FEE64 $BAK   ;#   restore
   }

 proc do_sync_asics {} { ;# cause a resync but don't request slaves load their Timestamps and don't reset the SYNC counters
	set BAK $::AIDA::FEE64   ;#   save
      foreach fee64 $::AIDA::ModuleMenu {
	          set ::AIDA::FEE64 $fee64
		  WriteAIDARegister 0x400 1 ; # Force the Slave to not be in ReSYNC mode!
		  set myval [ ReadAIDARegister 0x300 ]
		  WriteAIDARegister 0x300 [ expr $myval | 0x10000 ] ;# enable the resync synchronisation
	}

	set ::AIDA::FEE64 $::AIDA::TSMaster   ;# select Master
            WriteAIDARegister 0x412 0            ;# write to copy timestamp 
            set MTimeH [ReadAIDARegister 0x413]   ;# read timestamp high 32 bits
            set MTimeL [ReadAIDARegister 0x412]   ;# read timestamp low 32 bits

            InsertLog "Current master timestamp from $::AIDA::FEE64 is $MTimeH $MTimeL"

            if {[expr ($MTimeL >> 28) & 0xf] >= 0xe} {
                set NewTimeL 0x20000000   ; # extended the period between the current time and the resync time by 0x10000000
                set NewTimeH [format 0x%08x [expr $MTimeH + 1]]
            } else {
                set NewTimeL [format 0x%08x [expr ($MTimeL & 0xf0000000) + 0x30000000]]
                set NewTimeH $MTimeH
            }

            WriteAIDARegister 0x417 $NewTimeL    ;#   load timestamp used by master to generate ReSYNC pulse
            WriteAIDARegister 0x418 $NewTimeH    ;# 

            WriteAIDARegister 0x410 0xB        ;#   master generates RESYNC request but doesn't reset the number of SYNCs issued.

            InsertLog "ReSync at time $NewTimeH $NewTimeL"
#    check status from the master

      for {set i 0} {$i < 10} {incr i} {

         set STATUS [ReadAIDARegister 0x411]    ;#  Master timestamp status
         if {$STATUS == 0x1} {
             InsertLog "Master ReSync done"
             break
         } else {
             after 2000  ;#  wait a bit longer
         }
      }

      if {$i == 10} {InsertLog "Warning: Master ReSync NOT complete"}
      WriteAIDARegister 0x410 1 ;# reset the ReSync request in the Master

 	set Master_issued [ ReadAIDARegister 0x41B ] ;# read the number the Master thinks it sent out
	InsertLog "Master issued [format "%d" $Master_issued ] SYNC pulses"
      foreach fee64 $::AIDA::ModuleMenu {
	          set ::AIDA::FEE64 $fee64
		  set status [ ReadAIDARegister 0x302 ] 
		  InsertLog "Slave $fee64 Status register = $status"
		  set myval [ ReadAIDARegister 0x300 ]
		  WriteAIDARegister 0x300 [ expr $myval & 1 ] ;# disable the resync synchronisation but leave go as it was

	}
	set ::AIDA::FEE64 $BAK   ;#   restore
   }

   proc do_redisplay {} {
}

   proc do_collect_info {} {
	global env
    set BAK $::AIDA::FEE64   ;#   save

	set r [namespace eval ::DataAcquisitionControl do_setopt "CollectInfo"]
	after 500 ;# wait for the files to be written
	InsertLog "Returned $r "
	InsertLog "Mem(KB)       4     8    16    32   64    128     256    512    1k    2k    4k"
	set f [ file join $env(MIDASBASE) XilinxLinux ppc_4xx rfs ]
      	foreach fee64 $::AIDA::ModuleMenu {
	  	set ::AIDA::FEE64 $fee64
		set mybuddy [ file join $f $fee64 tmp mybuddy.txt ]
		for { set i 0 } { $i < 10 } { incr i } {
			set file_size [ file size $mybuddy ]
			if { $file_size > 0 } break ;
			after 500 
		}
#InsertLog "$fee64 : took $i loops"
		set fp [ open $mybuddy r ]
		set results [ read $fp ]
		set Rlist [split $results ]
		set Dposn [ expr [ lsearch $Rlist "DMA" ] + 1 ]
		set Vlist [ lrange $Rlist $Dposn end ] ;# extracted just the numbers 
#InsertLog "$Vlist, $Dposn"
		set size_value 4
		set mem_total 0
		foreach val $Vlist {
			if { $val != "" } {
				set mem_total [ expr $size_value * $val + $mem_total ]
				set size_value [ expr $size_value * 2 ]
			}
		}
		set Ostring [ join $Vlist ]
		InsertLog "$fee64 : $Ostring : $mem_total"	
	}
      set ::AIDA::FEE64 $BAK   ;#   restore
}

   proc Show_SYNCRX_Counters {} {
    set BAK $::AIDA::FEE64   ;#   save

      foreach fee64 $::AIDA::ModuleMenu {
	  	set ::AIDA::FEE64 $fee64
		set val$fee64 [ ReadAIDARegister [ expr 0x400 + 7] ]
	}
     foreach fee64 $::AIDA::ModuleMenu {
		InsertLog "$fee64 => [format "%d" [ set val$fee64 ] ]"
	}
      set ::AIDA::FEE64 $BAK   ;#   restore
}
 
   proc Show_SYNC_Counters {} {
    set BAK $::AIDA::FEE64   ;#   save

      foreach fee64 $::AIDA::ModuleMenu {
	  	set ::AIDA::FEE64 $fee64
		set val [ ReadAIDARegister [ expr 0x400 + 14] ]
		InsertLog "$fee64 => [format "%d" $val ]"
	}
      set ::AIDA::FEE64 $BAK   ;#   restore
}

   proc Collect_SYNC_Base {} {
     variable SYNC_Base_Collected
     set BAK $::AIDA::FEE64   ;#   save

      foreach fee64 $::AIDA::ModuleMenu {
	  	set ::AIDA::FEE64 $fee64
		variable Sync_Base_$fee64
		set Sync_Base_$fee64 [ ReadAIDARegister [ expr 0x400 + 14] ]
	}
      set SYNC_Base_Collected 1
      set ::AIDA::FEE64 $BAK   ;#   restore
}
   proc do_wrstatus {} {
	variable WR_Base_Collected
     set BAK $::AIDA::FEE64   ;#   save
	set passed 0 
	set failed 0
	if { $WR_Base_Collected == 0 } { Collect_WR_Base }
      foreach fee64 $::AIDA::ModuleMenu {
	  	set ::AIDA::FEE64 $fee64
		variable WR_Base_$fee64
		set base [ set WR_Base_$fee64 ]
		set wrcount [ ReadAIDARegister [ expr 0x400 + 2] ]
		if { $wrcount != $base } {
			set failed [ expr $failed + 1]
			InsertLog "$fee64 failed. WR error count => $base : $wrcount"
		} else {
			set passed [ expr $passed +1 ]
		}
	}
	InsertLog "White Rabbit error counter test result: Passed $passed, Failed $failed"
      set ::AIDA::FEE64 $BAK   ;#   restore
}
   proc Collect_WR_Base {} {
     variable WR_Base_Collected
     set BAK $::AIDA::FEE64   ;#   save

      foreach fee64 $::AIDA::ModuleMenu {
	  	set ::AIDA::FEE64 $fee64
		variable WR_Base_$fee64
		set WR_Base_$fee64 [ ReadAIDARegister [ expr 0x400 + 2] ]
	}
      set WR_Base_Collected 1
      set ::AIDA::FEE64 $BAK   ;#   restore
}
   proc Sync_ASIC_Clock {} {
     set BAK $::AIDA::FEE64   ;#   save

      foreach fee64 $::AIDA::ModuleMenu {
	  set ::AIDA::FEE64 $fee64
	  set val [ ReadAIDARegister 0x300 ]
	  WriteAIDARegister 0x300 [ expr $val | 0x10000	] ;# enable the ASIC clock synchronisation
     }

      after 10 			;# allow time for several sync pulses

      foreach fee64 $::AIDA::ModuleMenu {
	  set ::AIDA::FEE64 $fee64
	  set val [ ReadAIDARegister 0x300 ]
	  WriteAIDARegister 0x300 [ expr $val & 0xFFFF ]		;# remove the enable the ASIC clock synchronisation
     }
      set ::AIDA::FEE64 $BAK   ;#   restore
	do_stamp_check

}
   proc do_setOpt {i vl} {
      variable allmodules

      set BAK $::AIDA::FEE64   ;#   save

      foreach fee64 $::AIDA::ModuleMenu {
          if {$allmodules == 0 && $fee64 != $::AIDA::FEE64} continue

          set ::AIDA::FEE64 $fee64

      }

      set ::AIDA::FEE64 $BAK   ;#   restore
   }

   proc  do_click {}  {
       variable cgidata
       variable started
       variable LogFlag
       variable ShowLogFlag

       set cgidata [ncgi::nvlist]

       if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

       if {[llength $cgidata] == 0} then {return}

       if {[llength $cgidata] < 2} then {
           InsertLog "CGI data is too short: $cgidata"
       } else {
           if {[lindex $cgidata 0] != "Widget"} then {
               InsertLog "Invalid CGI data: $cgidata"
           } else {

              set w [first [lindex $cgidata 1]]
              set vl [second [lindex $cgidata 1]]

               switch -glob $w {

                   RESET    {set started 0}
                   CLEAR    {EmptyLog}
                   ELOG     {PrintLog}
                   RELOAD   {}
                   VARIABLES {show_variables}

                   HIDE     {set ShowLogFlag 0}
                   SHOW     {set ShowLogFlag 1}
                   LOGON    {set LogFlag 1}
                   LOGOFF   {set LogFlag 0}

		STAMP_CHECK {do_stamp_check}
		CAL_CHECK	{do_cal_check}
		CLOCK_CHECK { do_clock_check }
		SYNC_CHECK { do_sync_check }
		SYNC_CHECKRX { do_sync_checkRx }
		COLLECTINFO { do_collect_info }
		WRSTATUS { do_wrstatus }

                   EXPERT   {$vl}

                   MainLog {}
                   undefined {}
                   default {InsertLog "unexpected CGI data:  $cgidata"}
               }
           }
        }
        do_redisplay
     }

}   ;# end of if {$started == 0}




