


# variable started 0

if {![info exists started]} {variable started 0}

if {$started != 0} {

     variable JS ""
     variable LogFlag

     if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    do_click
}

if {$started == 0} {           ;#  first time load code and define local variables
    set started 1

    variable LogText ""
    variable LogFlag 0
    variable LogCount 0

    variable ShowLogFlag 0

    variable JS ""

    variable Ports {}

    variable Port   /dev/ttyUSB0
    variable Baud 19200
    variable Data 8
    variable Parity n
    variable Stop 2

    variable Flow none

    variable channelId 0

    variable VERSION 0
    variable DC 0
    variable STATUS 0


    proc show_variables {} {
        variable LogFlag
        variable LogCount
        variable ShowLogFlag
        variable Ports


         InsertLog "LogFlag=$LogFlag; LogCount=$LogCount; ShowLogFlag=$ShowLogFlag"
         InsertLog "DC=[DC]; Status=[Status]"
         InsertLog "Ports = $Ports"

         set Port /dev/ttyUSB0
         if {![file exists $Port]} {InsertLog "$Port does not exist"; return}
         InsertLog "Selected Port $Port"
         set rc [catch {exec sudo -n chmod 666 $Port} m]
         InsertLog "setting access permisssions; rc=$rc; m=$m"
         set rc [catch {open $Port RDWR} m]
         InsertLog "Accessing port $Port; rc=$rc; m=$m"
         set channelId $m
         set rc [catch {close $channelId} m]
         InsertLog "Closing port $Port; rc=$rc; m=$m"
    }

   proc SetPort {p} {
      variable Port

      do_disconnect
      set Port $p
      do_connect
   }

   proc FindPorts {} {
       variable Port
       variable Ports

       set Ports {}

       for {set p 0} {$p < 8} {incr p} {
          if {![file exists /dev/ttyUSB$p]} {continue}

          set Port /dev/ttyUSB$p
          do_connect

          set V [VERS]
          if {$V > 0} {
              InsertLog "port $Port: firmware version = $V"
              lappend Ports $Port
          }
          do_disconnect
       }

       set Port [first $Ports]
   }

proc do_connect {} {
   global env
   variable channelId
   variable Port
   variable Baud
   variable Data
   variable Parity
   variable Stop
   variable Flow

   if {$channelId != 0} {
       InsertLog "Already connected: Disconnect first"
       return
   }

          if {$env(os) == "Linux" || $env(os) == "Linux64"} {
               set z [catch {exec sudo -n chmod 666 $Port} m]   ;# need rw access to serial port
               if {$z != 0} {InsertLog "failed to change access mode to I/O port\n$m"; return}
          }

          set rc [catch {open $Port RDWR} m]
          if {$rc == 0} {set channelId $m; InsertLog "Using $Port"} else {InsertLog "$Port: $m"}

          if {$channelId != 0} {
             fconfigure $channelId -mode $Baud,$Parity,$Data,$Stop -handshake $Flow
             fconfigure $channelId -blocking no -buffering none -translation binary
             fileevent $channelId readable GetData
         }

}

proc do_disconnect {} {
   variable channelId
   variable Port

   if {$channelId == 0} {
#       InsertLog "Already disconnected"
   } else {
       set z [catch {close $channelId} m]
       set channelId 0
       set Port /dev/null
   }
}

proc SetOff {n} {
    variable channelId

   if {$channelId == 0} {do_connect}

   if {$channelId == 0} {InsertLog "Not connected"; return}

   switch $n {
      1  {puts $channelId "o"}
      2  {puts $channelId "p"}
      3  {puts $channelId "q"}
      4  {puts $channelId "r"}
      5  {puts $channelId "s"}
      6  {puts $channelId "t"}
      7  {puts $channelId "u"}
      8  {puts $channelId "v"}
      default {}
   }

   Status
}

proc SetOn {n} {
    variable channelId

   if {$channelId == 0} {do_connect}

   if {$channelId == 0} {InsertLog "Not connected"; return}

   switch $n {
      1  {puts $channelId "e"}
      2  {puts $channelId "f"}
      3  {puts $channelId "g"}
      4  {puts $channelId "h"}
      5  {puts $channelId "i"}
      6  {puts $channelId "j"}
      7  {puts $channelId "k"}
      8  {puts $channelId "l"}
      default {}
   }

   Status
}

proc SequenceOn {} {
    variable channelId

   if {$channelId == 0} {do_connect}

   if {$channelId == 0} {InsertLog "Not connected"; return}

   foreach chan { 1 2 3 4 5 6 7 8 } {
	SetOn $chan
	after 500
	}
}


proc AllOff {} {
    variable channelId

   if {$channelId == 0} {do_connect}

   if {$channelId == 0} {InsertLog "Not connected"; return}

   set z [catch {puts $channelId "n"} m]
   if {$z != 0} {return}

   Status
}

proc AllOn {} {
    variable channelId

   if {$channelId == 0} {do_connect}

   if {$channelId == 0} {InsertLog "Not connected"; return}

   set z [catch {puts $channelId "d"} m]
   if {$z != 0} {return}

   Status
}

proc DC {} {
    variable channelId
    variable DC

   if {$channelId == 0} {do_connect}

   if {$channelId == 0} {InsertLog "Not connected"; return}

   set z [catch {puts $channelId "\]"} m]
   if {$z != 0} {return}
after 200
   set DC [expr 0x[GetData]]
}

proc VERS {} {
    variable channelId
    variable VERSION

   if {$channelId == 0} {do_connect}

   if {$channelId == 0} {InsertLog "Not connected"; return}

   set z [catch {puts $channelId "Z"} m]
   if {$z != 0} {return}
after 200
   set VERSION [GetData]
}

proc Status {} {
    variable channelId
    variable STATUS

   if {$channelId == 0} {do_connect}

   if {$channelId == 0} {InsertLog "Not connected"; return}

   set z [catch {puts $channelId "\["} m]
   if {$z != 0} {return}
after 500
   set z [catch {set STATUS [expr 0x[GetData]]} m]
}

proc GetData {args} {
    variable channelId

   if {$channelId == 0} {do_connect}

   if {$channelId == 0} {InsertLog "Not connected"; return 0}

    set data [read $channelId 132]
    if {[string length $data] == 0} {return 0}

    set line ""
    for {set i 0} {$i < [string length $data]} {incr i} {
        set c1 [string range $data $i $i]
        binary scan $c1 H2 c2
        append line "[set c2]"
    }

    return "$line"
}

   proc do_click {} {
       variable cgidata
       variable started
       variable LogFlag
       variable ShowLogFlag
       variable JS

       set cgidata [ncgi::nvlist]

       if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

       if {[llength $cgidata] == 0} then {return}

       if {[llength $cgidata] < 2} then {
           InsertLog "CGI data is too short: $cgidata"
       } else {
           if {[lindex $cgidata 0] != "Widget"} then {
               InsertLog "Invalid CGI data: $cgidata"
           } else {

               set w  [first  [lindex $cgidata 1]]
               set vl [second [lindex $cgidata 1]]

               switch -glob $w {

                   RESET    {catch {do_disconnect}; set started 0}
                   CLEAR    {EmptyLog}
                   ELOG     {PrintLog}
                   RELOAD   {}
                   VARIABLES {show_variables}

                   HIDE     {set ShowLogFlag 0}
                   SHOW     {set ShowLogFlag 1}
                   LOGON    {set LogFlag 1}
                   LOGOFF   {set LogFlag 0}

                   SEQ       {SequenceOn}
                   PORT      {SetPort $vl}
                   ALLON     {AllOn}
                   ALLOFF    {AllOff}
                   RELAYON   {SetOn $vl}
                   RELAYOFF  {SetOff $vl}

                   MainLog {}
                   undefined {}
                   default {InsertLog "unexpected CGI data: [lindex $w 0]: $cgidata"}
               }
           }
       }
       catch {Status}
    }

    FindPorts

}   ;# end of if {$started == 0}



