
#    Note:  This is loaded into the namespace  SYSMON

# variable started 0

if {![info exists started]} {variable started 0}

if {$started != 0} {

     variable JS ""
     variable LogFlag

     if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}



    do_click
}

if {$started == 0} {           ;#  first time load code and define SYSMON variables
    set started 1

    variable ShowLogFlag 0

    variable LogText ""
    variable LogFlag 0
    variable LogCount 0

    variable JS ""



	variable RegBase 0x4100

	variable RegList { 0 0x24 0 0x20 0x25 1 0x21 0x26 2 0x22 }

	foreach item $::AIDA::ModuleMenu {
#		InsertLog "Doing create for $item"
    		variable Opt900$item "$item"
     		variable Opt901$item "-"
     		variable Opt902$item "-"
     		variable Opt903$item "-"
    		variable Opt904$item "-" 
    		variable Opt905$item "-" 
    		variable Opt906$item "-" 
    		variable Opt907$item "-" 
    		variable Opt908$item "-" 
    		variable Opt909$item "-" 

	}



   proc  show_variables {} {
       variable allmodules
    	variable REGMAX
       InsertLog "FEE64 = $::AIDA::FEE64"
       InsertLog "all modules = $allmodules"
       
   }
   proc Reset_SYSMON {} {
	variable RegBase
	set BAK $::AIDA::FEE64

	foreach item $::AIDA::ModuleMenu {
		set ::AIDA::FEE64 $item
		WriteAIDARegister 12 2 ;# reset the monitor
	}
	foreach item $::AIDA::ModuleMenu {
		set ::AIDA::FEE64 $item
		WriteAIDARegister 12 0 ;# remove the reset.
	}

	set ::AIDA::FEE64 $BAK
}
   proc GetSysTemperature { reg } {
	variable RegBase
	variable RegList
	set val  [ expr [ReadAIDARegister [ expr $RegBase + [ lindex $RegList $reg]]]  >> 6 ]
	set temperature [ format "%2.2f" [ expr ( ( $val * 503.975 ) / 1024.0 ) - 273.15 ] ]
	return $temperature
}

   proc GetSysVoltage { reg } {
	variable RegBase
	variable RegList
	set val  [ expr [ReadAIDARegister [ expr $RegBase + [ lindex $RegList $reg]]]  >> 6 ]
	set voltage [ format "%2.3f" [ expr  ( $val * 3.0 ) / 1024.0   ] ]
	return $voltage


}

   proc do_redisplay {} {
	variable RegBase
	variable RegList
		set BAK $::AIDA::FEE64

	foreach item $::AIDA::ModuleMenu {
		set ::AIDA::FEE64 $item
		WriteAIDARegister 12 1 ;# set the enable
		WriteAIDARegister [ expr $RegBase + 0x41 ]  0x80 ;# enable supply offset and gain calibration to be used 
     		variable Opt901$item  [ GetSysTemperature 1  ]
     		variable Opt902$item  [ GetSysTemperature 2  ]
     		variable Opt903$item  [ GetSysTemperature 3  ]
    		variable Opt904$item  [ GetSysVoltage 4 ] 
    		variable Opt905$item  [ GetSysVoltage 5 ]  
    		variable Opt906$item  [ GetSysVoltage 6 ]  
    		variable Opt907$item  [ GetSysVoltage 7 ]  
    		variable Opt908$item  [ GetSysVoltage 8 ]  
    		variable Opt909$item  [ GetSysVoltage 9 ]  
		WriteAIDARegister 12 0 ;# clear the enable
	}

	set ::AIDA::FEE64 $BAK
   }


   proc  do_click {}  {
       variable cgidata
       variable started
       variable LogFlag
       variable ShowLogFlag

       set cgidata [ncgi::nvlist]

       if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

       if {[llength $cgidata] == 0} then {return}

       if {[llength $cgidata] < 2} then {
           InsertLog "CGI data is too short: $cgidata"
       } else {
           if {[lindex $cgidata 0] != "Widget"} then {
               InsertLog "Invalid CGI data: $cgidata"
           } else {

              set w [first [lindex $cgidata 1]]
              set vl [second [lindex $cgidata 1]]

               switch -glob $w {

                   RESET    {set started 0}
                   CLEAR    {EmptyLog}
                   ELOG     {PrintLog}
                   RELOAD   {}
                   VARIABLES {show_variables}

                   HIDE     {set ShowLogFlag 0}
                   SHOW     {set ShowLogFlag 1}
                   LOGON    {set LogFlag 1}
                   LOGOFF   {set LogFlag 0}

                   EXPERT   {$vl}

                   MainLog {}
                   undefined {}
                   default {InsertLog "unexpected CGI data:  $cgidata"}
               }
           }
        }
        do_redisplay
     }

}   ;# end of if {$started == 0}




