
#    Note:  This is loaded into the namespace  TS_WR

# variable started 0

if {![info exists started]} {variable started 0}

if {$started != 0} {

     variable JS ""
     variable LogFlag

     if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    do_click
}

if {$started == 0} {           ;#  first time load code and define local variables
    set started 1

    variable ShowLogFlag 0

    variable LogText ""
    variable LogFlag 0
    variable LogCount 0

    variable JS ""

    variable allmodules 0

    for {set i 0} {$i <= 15} {incr i} {variable Opt$i 0}


   proc  show_variables {} {
       variable allmodules

       InsertLog "FEE64 = $::AIDA::FEE64"
       InsertLog "all modules = $allmodules"
     foreach i {0 1 2 3 4 14} {
        variable Opt$i
        InsertLog " Opt$i = [set Opt$i ]"
     }
   }
proc ListTimes {} {

      set BAK $::AIDA::FEE64   ;#   save

      foreach fee64 $::AIDA::ModuleMenu {

		WriteAIDARegister [expr 0x400 + 4] 1  ;# write a bit to request a copy of the timestamp is transferred to the readable register
		after 1 												;# waiting 1 millisecond guarantees a T0 if it's working ok.
        set TimeLSW [ReadAIDARegister [expr 0x400 + 4]]
		WriteAIDARegister [expr 0x400 + 4] 0  ;# reset a bit that requests a copy of the timestamp is transferred to the readable register
        set TimeMSW [ReadAIDARegister [expr 0x400 + 5]]
		set timestring [format " %08X %08X " $TimeMSW  $TimeLSW ]
		InsertLog "$fee64 : $timestring "
      }

      set ::AIDA::FEE64 $BAK   ;#   restore
}
	  
   proc do_redisplay {} {

     foreach i {0 1 2 3 4 5 6 7 14} {
        variable Opt$i
		if { $i == 4 } { WriteAIDARegister [expr 0x400 + $i] 1 } ;# write a bit to request a copy of the timestamp is transferred to the readable register
		after 1 												;# waiting 1 millisecond guarantees a T0 if it's working ok.
        set Opt$i [ReadAIDARegister [expr 0x400 + $i]]
		if { $i == 4 } { WriteAIDARegister [expr 0x400 + $i] 0 } ;# reset a bit that requests a copy of the timestamp is transferred to the readable register
		
     }
   }

   proc do_setOpt {i vl} {
      variable allmodules

      set BAK $::AIDA::FEE64   ;#   save

      foreach fee64 $::AIDA::ModuleMenu {
          if {$allmodules == 0 && $fee64 != $::AIDA::FEE64} continue

          set ::AIDA::FEE64 $fee64
          WriteAIDARegister [expr 0x400 + $i] $vl
      }

      set ::AIDA::FEE64 $BAK   ;#   restore
   }


   proc  do_click {}  {
       variable cgidata
       variable started
       variable LogFlag
       variable ShowLogFlag

       set cgidata [ncgi::nvlist]

       if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

       if {[llength $cgidata] == 0} then {return}

       if {[llength $cgidata] < 2} then {
           InsertLog "CGI data is too short: $cgidata"
       } else {
           if {[lindex $cgidata 0] != "Widget"} then {
               InsertLog "Invalid CGI data: $cgidata"
           } else {

              set w [first [lindex $cgidata 1]]
              set vl [second [lindex $cgidata 1]]

               switch -glob $w {

                   RESET    {set started 0}
                   CLEAR    {EmptyLog}
                   ELOG     {PrintLog}
                   RELOAD   {}
                   VARIABLES {show_variables}

                   HIDE     {set ShowLogFlag 0}
                   SHOW     {set ShowLogFlag 1}
                   LOGON    {set LogFlag 1}
                   LOGOFF   {set LogFlag 0}

                   MODULE     {set ::AIDA::FEE64 $vl}
                   ALLMODULES {variable allmodules; set allmodules [expr ($allmodules + 1) & 1]}

                   OPTS     {do_setOpt [second [lindex $cgidata 1]] [third [lindex $cgidata 1]]}
                   EXPERT   {$vl}

                   MainLog {}
                   undefined {}
                   default {InsertLog "unexpected CGI data:  $cgidata"}
               }
           }
        }
        do_redisplay
     }

}   ;# end of if {$started == 0}




