
#    MIDAS Access Server  for XAD9252 


package require MIDASDomainHandler     ;#  load default support procedures

set z [catch {package require XAD9252Access 1.0} m]
if {$z != 0} {puts $m}

global MIDAS_XAD9252AccessServer_Exists
set MIDAS_XAD9252AccessServer_Exists 0

global MIDAS_XAD9252AccessServer_Verbose
set MIDAS_XAD9252AccessServer_Verbose 0

# Use namespaces to isolate our methods
namespace eval urn:XAD9252AccessServer {

    proc AccessServerVerbose {option} {
        do_AccessServerVerbose $option
        return [rpcvar::rpcvar int 0]
    }

    proc Set {Chip Address Value} {
        do_Set $Chip $Address $Value
        return [rpcvar::rpcvar int 0]
    }

    proc LM3000Set {Chip Value} {
        do_LM3000Set $Chip  $Value
        return [rpcvar::rpcvar int 0]
    }

    proc Get {Chip Address} {
        set vl [do_Get $Chip $Address]
        return [rpcvar::rpcvar int $vl]
    }

    proc do_AccessServerVerbose {option} {
        global MIDAS_XAD9252AccessServer_Verbose
        if {$MIDAS_XAD9252AccessServer_Verbose} {puts "called method AccessServerVerbose with parameter $option"}
        set MIDAS_XAD9252AccessServer_Verbose $option
        XAD9252Access_Verbose $option
    }

    proc do_Set {Chip Address Value} {
       global MIDAS_XAD9252AccessServer_Verbose

       if {$MIDAS_XAD9252AccessServer_Verbose} \
          {puts "do_Set $Chip $Address ([format "0x%x" $Chip] [format "0x%x" $Address]) = $Value"}

       set z [catch {XAD9252Access_Set -c $Chip -a $Address -d $Value} m]
       if {$z == 0} then {
          return 0
       } else {
           return -code error -errorcode 0x10005 -errorinfo "received error response: rc=$z\n  $m"
       }
    }

    proc do_LM3000Set {Chip Value} {
       global MIDAS_XAD9252AccessServer_Verbose

       if {$MIDAS_XAD9252AccessServer_Verbose} \
          {puts "do_Set $Chip ([format "0x%x" $Chip]) = $Value"}

       set z [catch {XAD9252Access_LM3000Set -c $Chip -d $Value} m]
       if {$z == 0} then {
          return 0
       } else {
           return -code error -errorcode 0x10005 -errorinfo "received error response: rc=$z\n  $m"
       }
    }

    proc do_Get {Chip Address} {
       global MIDAS_XAD9252AccessServer_Verbose

       set z [catch {XAD9252Access_Get -c $Chip -a $Address} m]
       if {$z == 0} then {
          if {$MIDAS_XAD9252AccessServer_Verbose} \
             {puts "do_Get $Address ([format "0x%x" $Chip] [format "0x%x" $Address]) = $m"}
          return $m
       } else {
           if {$MIDAS_XAD9252AccessServer_Verbose} \
              {puts "do_Get $Address ([format "0x%x" $Chip] [format "0x%x" $Address])"}
           return -code error -errorcode 0x10005 -errorinfo "received error response: rc=$z\n  $m"
       }
    }


    # We have to publish the public methods...

     SOAP::export AccessServerVerbose
     SOAP::export Set
     SOAP::export LM3000Set
     SOAP::export Get
}

# register this service with tclhttpd
puts [SOAP::Domain::register  -prefix  /XAD9252AccessServer  -namespace urn:XAD9252AccessServer -uri urn:XAD9252AccessServer]


proc ::SOAP::Domain::MIDAS_SOAPDomainHandler_/XAD9252AccessServer {optsname sock args} {   \
    ::SOAP::Domain::MIDAS_SOAPDomainHandler_/DefaultAccessServer $optsname $sock $args}

package provide XAD9252AccessServer 1.0
